Debian Bug report logs - #599643
libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them

version graph

Package: libm17n-0; Maintainer for libm17n-0 is Harshula Jayasuriya <harshula@debian.org>; Source for libm17n-0 is src:m17n-lib.

Reported by: Josh Triplett <josh@joshtriplett.org>

Date: Sat, 9 Oct 2010 20:18:01 UTC

Severity: normal

Found in version m17n-lib/1.6.1-1

Fixed in version m17n-lib/1.6.2-1

Done: Harshula Jayasuriya <harshula@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, josh@joshtriplett.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#599643; Package libm17n-0. (Sat, 09 Oct 2010 20:18:04 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them
Date: Sat, 09 Oct 2010 13:14:18 -0700
Package: libm17n-0
Version: 1.6.1-1
Severity: normal

libm17n-0, as a library, primarily gets pulled in by other packages
installed by the user, rather than through direct user installation.

libm17n-0 recommends m17n-contrib and m17n-db, but does not give any
indication of the functionality these packages provide for programs that
use libm17n-0, making it difficult for a user to sensibly decide whether
to install them.  For instance, emacs23 depends on libm17n-0, and seems
to work fine without these packages installed; what functionality of
emacs23 would not work without installing these packages?

In general, these packages don't seem like "packages that would be found
together with this one in all but unusual installations".

Please consider documenting the reason a user might want to install
these packages in libm17n-0's description, and please consider carefully
whether these packages need a Recommends or whether a Suggests would
suffice, particularly since Recommends get installed by default now.

Thanks,
Josh Triplett

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.36-rc6-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.utf8, LC_CTYPE=en_US.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libm17n-0 depends on:
ii  libanthy0              9100h-6           input method for Japanese - runtim
ii  libc6                  2.11.2-6          Embedded GNU C Library: Shared lib
ii  libfontconfig1         2.8.0-2.1         generic font configuration library
ii  libfreetype6           2.4.2-2           FreeType 2 font engine, shared lib
ii  libfribidi0            0.19.2-1          Free Implementation of the Unicode
ii  libgd2-xpm             2.0.36~rc1~dfsg-4 GD Graphics Library version 2
ii  libice6                2:1.0.6-1         X11 Inter-Client Exchange library
ii  libotf0                0.9.11-1          A Library for handling OpenType Fo
ii  libsm6                 2:1.1.1-1         X11 Session Management library
ii  libthai0               0.1.14-2          Thai language support library
ii  libx11-6               2:1.3.3-3         X11 client-side library
ii  libxft2                2.1.14-2          FreeType-based font drawing librar
ii  libxml2                2.7.7.dfsg-4      GNOME XML library
ii  libxrender1            1:0.9.6-1         X Rendering Extension client libra
ii  libxt6                 1:1.0.7-1         X11 toolkit intrinsics library
ii  zlib1g                 1:1.2.3.4.dfsg-3  compression library - runtime

Versions of packages libm17n-0 recommends:
pn  m17n-contrib                  <none>     (no description available)
pn  m17n-db                       <none>     (no description available)

Versions of packages libm17n-0 suggests:
pn  m17n-docs                     <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#599643; Package libm17n-0. (Sun, 10 Oct 2010 17:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Sun, 10 Oct 2010 17:03:03 GMT) Full text and rfc822 format available.

Message #8 received at 599643@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Josh Triplett <josh@joshtriplett.org>, 599643@bugs.debian.org
Subject: Re: Bug#599643: libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them
Date: Mon, 11 Oct 2010 03:43:27 +1100
Hi Josh,

On Sat, 2010-10-09 at 13:14 -0700, Josh Triplett wrote:

> libm17n-0 recommends m17n-contrib and m17n-db, but does not give any
> indication of the functionality these packages provide for programs that
> use libm17n-0, making it difficult for a user to sensibly decide whether
> to install them.  For instance, emacs23 depends on libm17n-0, and seems
> to work fine without these packages installed; what functionality of
> emacs23 would not work without installing these packages?
> 
> In general, these packages don't seem like "packages that would be found
> together with this one in all but unusual installations".

You've raised an interesting question. My initial reaction is Emacs
should Depend on both libm17n-0 and m17n-db. Emacs appears to use
libm17n and m17n-db for complex text layout. libm17n contains the C API
and m17n-db contains the layout rules. So without both packages Emacs
will not function correctly. For example, copy the following Sinhala
text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
a screenshot. Then remove m17n-db and copy the text into Emacs and see
the difference.

The upstream developers decided to split external contributions to
m17n-db into m17n-contrib. However, my understanding is that they will
merge in the next major release.

> Please consider documenting the reason a user might want to install
> these packages in libm17n-0's description, and please consider carefully
> whether these packages need a Recommends or whether a Suggests would
> suffice, particularly since Recommends get installed by default now.

The relationship is either Recommends or Depends. Definitely not
Suggests. Should a package's description contain explanations as to why
it Recommends other packages? Is that a requirement? Do other packages
already do this?

m17n-db description already contains: "This package contains the
database files used by m17n-lib."

m17n-contrib description already contains: "This package contains the
database files contributed by the community and used by m17n-lib."

cya,
#





Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#599643; Package libm17n-0. (Mon, 11 Oct 2010 00:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Josh Triplett <josh@joshtriplett.org>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Mon, 11 Oct 2010 00:57:06 GMT) Full text and rfc822 format available.

Message #13 received at 599643@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Harshula <harshula@gmail.com>
Cc: 599643@bugs.debian.org
Subject: Re: Bug#599643: libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them
Date: Sun, 10 Oct 2010 17:53:25 -0700
On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:
> On Sat, 2010-10-09 at 13:14 -0700, Josh Triplett wrote:
> > libm17n-0 recommends m17n-contrib and m17n-db, but does not give any
> > indication of the functionality these packages provide for programs that
> > use libm17n-0, making it difficult for a user to sensibly decide whether
> > to install them.  For instance, emacs23 depends on libm17n-0, and seems
> > to work fine without these packages installed; what functionality of
> > emacs23 would not work without installing these packages?
> > 
> > In general, these packages don't seem like "packages that would be found
> > together with this one in all but unusual installations".
> 
> You've raised an interesting question. My initial reaction is Emacs
> should Depend on both libm17n-0 and m17n-db. Emacs appears to use
> libm17n and m17n-db for complex text layout. libm17n contains the C API
> and m17n-db contains the layout rules. So without both packages Emacs
> will not function correctly. For example, copy the following Sinhala
> text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
> a screenshot. Then remove m17n-db and copy the text into Emacs and see
> the difference.

Interesting.  It didn't make a difference with the default font I
normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
character moved before the quote.  Does that sound like the correct
behavior?

> The upstream developers decided to split external contributions to
> m17n-db into m17n-contrib. However, my understanding is that they will
> merge in the next major release.

Good to know.

> > Please consider documenting the reason a user might want to install
> > these packages in libm17n-0's description, and please consider carefully
> > whether these packages need a Recommends or whether a Suggests would
> > suffice, particularly since Recommends get installed by default now.
> 
> The relationship is either Recommends or Depends. Definitely not
> Suggests.

From your explanation, it certainly sounds that way, and it sounds like
a "Depends" to me.  If a program uses libm17n, it expects to do text
layout *correctly*, and if libm17n can't do that in general without an
extra database, then that database represents a necessary component of
the library, as much so as all the various libfoo-common packages
floating around Debian.  Making it a Recommends so people can save a few
bytes by breaking text layout for languages more complex than English
seems wrong; how would people even begin to figure out how to fix such a
problem?  Anyone who cares *that* much about space can use techniques
like localepurge or dpkg exclusion and handle the corresponding
breakage; meanwhile, packages in Debian should Just Work for their
primary intended purpose.

Does that sound reasonable?

> Should a package's description contain explanations as to why
> it Recommends other packages? Is that a requirement? Do other packages
> already do this?

Every time a package has a Recommends or Suggests instead of a Depends,
the user may have to make a decision about whether to install the
package or not.  Many packages do include an explanation for their
Recommends and Suggests to help the user make such a decision.  For an
extreme example, see devscripts; for a simpler case, see gnupg and
gnupg-curl.

> m17n-db description already contains: "This package contains the
> database files used by m17n-lib."
> 
> m17n-contrib description already contains: "This package contains the
> database files contributed by the community and used by m17n-lib."

"used by" doesn't say how, and more importantly doesn't answer the
questions automatically raised by the use of Recommends rather than
Suggests: "If foo doesn't have a Depends on bar, then how does foo
manage to do without bar, or what can foo do with bar that it can't
without, or what part of foo will break or lose functionality if I don't
install bar?"

So, if you decide not to use Depends, I'd suggest explicitly saying
something like "libm17n requires m17n-db and m17n-contrib to handle
languages with complex text layout requirements."

But again, it seems questionable why someone would want to cripple m17n
by not installing those packages.  Similarly, someone *could* omit key
pieces of emacs, such as major modes for uncommon languages, and put
them in a separate package with a Recommends; however, those represent a
sufficiently expected part of the functionality of emacs that they need
a Depends-level "always installed" relationship.

By contrast, gdm3 only Recommends xserver-xephyr, because it can use
xephyr to implement the nested login functionality, but people wouldn't
consider gdm3 *broken* without that functionality.

- Josh Triplett




Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#599643; Package libm17n-0. (Tue, 12 Oct 2010 09:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Harshula <harshula@gmail.com>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Tue, 12 Oct 2010 09:45:05 GMT) Full text and rfc822 format available.

Message #18 received at 599643@bugs.debian.org (full text, mbox):

From: Harshula <harshula@gmail.com>
To: Josh Triplett <josh@joshtriplett.org>
Cc: 599643@bugs.debian.org
Subject: Re: Bug#599643: libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them
Date: Tue, 12 Oct 2010 20:41:59 +1100
Hi Josh,

On Sun, 2010-10-10 at 17:53 -0700, Josh Triplett wrote:
> On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:

> > You've raised an interesting question. My initial reaction is Emacs
> > should Depend on both libm17n-0 and m17n-db. Emacs appears to use
> > libm17n and m17n-db for complex text layout. libm17n contains the C API
> > and m17n-db contains the layout rules. So without both packages Emacs
> > will not function correctly. For example, copy the following Sinhala
> > text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
> > a screenshot. Then remove m17n-db and copy the text into Emacs and see
> > the difference.
> 
> Interesting.  It didn't make a difference with the default font I
> normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
> character moved before the quote.  Does that sound like the correct
> behavior?

No, that does not sound correct. I forgot to mention one important step,
install ttf-sinhala-lklug.

When I upload the next version of m17n-lib, I'll make it Depend on
m17n-db and m17n-contrib. In the future, I expect m17n-db and
m17n-contrib will be merged.

cya,
#





Information forwarded to debian-bugs-dist@lists.debian.org, Harshula Jayasuriya <harshula@gmail.com>:
Bug#599643; Package libm17n-0. (Tue, 12 Oct 2010 15:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Josh Triplett <josh@joshtriplett.org>:
Extra info received and forwarded to list. Copy sent to Harshula Jayasuriya <harshula@gmail.com>. (Tue, 12 Oct 2010 15:57:07 GMT) Full text and rfc822 format available.

Message #23 received at 599643@bugs.debian.org (full text, mbox):

From: Josh Triplett <josh@joshtriplett.org>
To: Harshula <harshula@gmail.com>
Cc: 599643@bugs.debian.org
Subject: Re: Bug#599643: libm17n-0: Please document reason for m17n-contrib and m17n-db recommends, or downgrade them
Date: Tue, 12 Oct 2010 08:53:17 -0700
On Tue, Oct 12, 2010 at 08:41:59PM +1100, Harshula wrote:
> Hi Josh,
> 
> On Sun, 2010-10-10 at 17:53 -0700, Josh Triplett wrote:
> > On Mon, Oct 11, 2010 at 03:43:27AM +1100, Harshula wrote:
> 
> > > You've raised an interesting question. My initial reaction is Emacs
> > > should Depend on both libm17n-0 and m17n-db. Emacs appears to use
> > > libm17n and m17n-db for complex text layout. libm17n contains the C API
> > > and m17n-db contains the layout rules. So without both packages Emacs
> > > will not function correctly. For example, copy the following Sinhala
> > > text "කොහොමද" into Emacs with both libm17n-0 and m17n-db installed. Take
> > > a screenshot. Then remove m17n-db and copy the text into Emacs and see
> > > the difference.
> > 
> > Interesting.  It didn't make a difference with the default font I
> > normally use in Emacs (Neep Alt), but with DejaVu Sans Mono the first
> > character moved before the quote.  Does that sound like the correct
> > behavior?
> 
> No, that does not sound correct. I forgot to mention one important step,
> install ttf-sinhala-lklug.

Ah, I see.

> When I upload the next version of m17n-lib, I'll make it Depend on
> m17n-db and m17n-contrib. In the future, I expect m17n-db and
> m17n-contrib will be merged.

Thanks!

- Josh Triplett




Reply sent to Harshula Jayasuriya <harshula@gmail.com>:
You have taken responsibility. (Wed, 24 Nov 2010 14:36:12 GMT) Full text and rfc822 format available.

Notification sent to Josh Triplett <josh@joshtriplett.org>:
Bug acknowledged by developer. (Wed, 24 Nov 2010 14:36:12 GMT) Full text and rfc822 format available.

Message #28 received at 599643-close@bugs.debian.org (full text, mbox):

From: Harshula Jayasuriya <harshula@gmail.com>
To: 599643-close@bugs.debian.org
Subject: Bug#599643: fixed in m17n-lib 1.6.2-1
Date: Wed, 24 Nov 2010 14:33:54 +0000
Source: m17n-lib
Source-Version: 1.6.2-1

We believe that the bug you reported is fixed in the latest version of
m17n-lib, which is due to be installed in the Debian FTP archive:

libm17n-0-dbg_1.6.2-1_amd64.deb
  to main/m/m17n-lib/libm17n-0-dbg_1.6.2-1_amd64.deb
libm17n-0_1.6.2-1_amd64.deb
  to main/m/m17n-lib/libm17n-0_1.6.2-1_amd64.deb
libm17n-dev_1.6.2-1_amd64.deb
  to main/m/m17n-lib/libm17n-dev_1.6.2-1_amd64.deb
m17n-lib-bin_1.6.2-1_amd64.deb
  to main/m/m17n-lib/m17n-lib-bin_1.6.2-1_amd64.deb
m17n-lib_1.6.2-1.debian.tar.gz
  to main/m/m17n-lib/m17n-lib_1.6.2-1.debian.tar.gz
m17n-lib_1.6.2-1.dsc
  to main/m/m17n-lib/m17n-lib_1.6.2-1.dsc
m17n-lib_1.6.2.orig.tar.gz
  to main/m/m17n-lib/m17n-lib_1.6.2.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 599643@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Harshula Jayasuriya <harshula@gmail.com> (supplier of updated m17n-lib package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 23 Nov 2010 01:39:29 +1100
Source: m17n-lib
Binary: libm17n-0 libm17n-dev libm17n-0-dbg m17n-lib-bin
Architecture: source amd64
Version: 1.6.2-1
Distribution: unstable
Urgency: low
Maintainer: Harshula Jayasuriya <harshula@gmail.com>
Changed-By: Harshula Jayasuriya <harshula@gmail.com>
Description: 
 libm17n-0  - a multilingual text processing library - runtime
 libm17n-0-dbg - a multilingual text processing library - debugging symbols
 libm17n-dev - a multilingual text processing library - development
 m17n-lib-bin - a multilingual text processing library - utilities
Closes: 599643 601858
Changes: 
 m17n-lib (1.6.2-1) unstable; urgency=low
 .
   * New upstream release 1.6.2.
   * Update Standards-Version to Debian Policy 3.9.1. (No changes)
   * debian/control: Depends: m17n-db and m17n-contrib. (Closes: #599643)
   * PATCH: (make_locale): Don't call setlocale.  Just parse the arg NAME.
            (Closes: #601858)
Checksums-Sha1: 
 4eae5afd5011508f518882fdaac8b9558b6402fe 1405 m17n-lib_1.6.2-1.dsc
 9b9ada79357dd56c90c64cd36845c5537c363d79 1031508 m17n-lib_1.6.2.orig.tar.gz
 24087541e7cb9c4431896ee00d57ecacc6cbb812 10637 m17n-lib_1.6.2-1.debian.tar.gz
 4bf961b41baa6a14f1eacfebcf0419d0be96beef 299248 libm17n-0_1.6.2-1_amd64.deb
 4f1fff3975c60e06a67b9135f638572c6b7f8441 310030 libm17n-dev_1.6.2-1_amd64.deb
 9f346ec5a7b27edf6ded158beef5beaff7e4fd68 465872 libm17n-0-dbg_1.6.2-1_amd64.deb
 359da503b535413dfd7a4032c8ac035eca0db564 56110 m17n-lib-bin_1.6.2-1_amd64.deb
Checksums-Sha256: 
 880a98427d55b6e6c3d1210f31d46b2c64e12096af7725461b2f21e70a8162a1 1405 m17n-lib_1.6.2-1.dsc
 f15039a310e94d6b462c46c409a393e1b16d95f13fd0376361f07bbfc6adb5a3 1031508 m17n-lib_1.6.2.orig.tar.gz
 467d386381f32ed9759cc80b09a896e096f8126bb50e7e26193c7e13c51b7d14 10637 m17n-lib_1.6.2-1.debian.tar.gz
 1187081e470da6baa819d4a9a0b41ce4d98d71bc4f6521952dc23ee6bba19c21 299248 libm17n-0_1.6.2-1_amd64.deb
 2e1d505ecb2a0ba141c74a89b94f0c430d520e730e3df1a0e0a5d129b405f7c3 310030 libm17n-dev_1.6.2-1_amd64.deb
 9d78bc50b8b4abefec29ea81ce567882700814389d286cd2ff0438b6695149fe 465872 libm17n-0-dbg_1.6.2-1_amd64.deb
 e445773e04961d6f3f006f06dad34060b171edeba910f096b9e7cc67d138fd14 56110 m17n-lib-bin_1.6.2-1_amd64.deb
Files: 
 12b51bd543ac2510bdd43f54332fd0e7 1405 utils optional m17n-lib_1.6.2-1.dsc
 ad889ed85d4c24928e52f9865bc224ce 1031508 utils optional m17n-lib_1.6.2.orig.tar.gz
 8769c40dd187f44f2a1c083f7e5cb5e8 10637 utils optional m17n-lib_1.6.2-1.debian.tar.gz
 dd82f2ef494f0cc054925e76a1c2473c 299248 libs optional libm17n-0_1.6.2-1_amd64.deb
 cd13bc79b10948ed6ff621148adf501d 310030 libdevel optional libm17n-dev_1.6.2-1_amd64.deb
 596dd532819df92580a942fb84af8b05 465872 debug extra libm17n-0-dbg_1.6.2-1_amd64.deb
 11e84b97be0541c677e375e866ebc2c6 56110 utils optional m17n-lib-bin_1.6.2-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkztGmwACgkQnXMZMWIGYYyoUQCcCp6HOt67VxcKoJ5IGjiLC6ZP
lNkAn3T6qHIq+NT0tiR6O+aP3/GRYK7m
=77aQ
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 07 Feb 2011 08:02:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 15:51:23 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.